package com.hai.dao;

import com.hai.entity.HighCompanyAccount;
import com.hai.entity.HighCompanyAccountExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighCompanyAccountMapper extends HighCompanyAccountMapperExt {
    @SelectProvider(type=HighCompanyAccountSqlProvider.class, method="countByExample")
    long countByExample(HighCompanyAccountExample example);

    @DeleteProvider(type=HighCompanyAccountSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighCompanyAccountExample example);

    @Delete({
        "delete from high_company_account",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_company_account (company_id, org_id, ",
        "account_no, amounts, ",
        "`status`, create_time, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{companyId,jdbcType=BIGINT}, #{orgId,jdbcType=BIGINT}, ",
        "#{accountNo,jdbcType=VARCHAR}, #{amounts,jdbcType=DECIMAL}, ",
        "#{status,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighCompanyAccount record);

    @InsertProvider(type=HighCompanyAccountSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighCompanyAccount record);

    @SelectProvider(type=HighCompanyAccountSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="org_id", property="orgId", jdbcType=JdbcType.BIGINT),
        @Result(column="account_no", property="accountNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="amounts", property="amounts", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighCompanyAccount> selectByExample(HighCompanyAccountExample example);

    @Select({
        "select",
        "id, company_id, org_id, account_no, amounts, `status`, create_time, update_time, ",
        "ext_1, ext_2, ext_3",
        "from high_company_account",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="org_id", property="orgId", jdbcType=JdbcType.BIGINT),
        @Result(column="account_no", property="accountNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="amounts", property="amounts", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighCompanyAccount selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighCompanyAccountSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighCompanyAccount record, @Param("example") HighCompanyAccountExample example);

    @UpdateProvider(type=HighCompanyAccountSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighCompanyAccount record, @Param("example") HighCompanyAccountExample example);

    @UpdateProvider(type=HighCompanyAccountSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighCompanyAccount record);

    @Update({
        "update high_company_account",
        "set company_id = #{companyId,jdbcType=BIGINT},",
          "org_id = #{orgId,jdbcType=BIGINT},",
          "account_no = #{accountNo,jdbcType=VARCHAR},",
          "amounts = #{amounts,jdbcType=DECIMAL},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighCompanyAccount record);
}
